part of simulator_eurl_sasu;


class ChargeSasCsgCrds extends ChargeSas {

  double coefficient;
  double threshold;
  bool isDeductible = false;

  ChargeSasCsgCrds(String name, double rateEmployee, double rateEmployer, double coefficient, double threshold, bool isDeductible) : super(name, rateEmployee, rateEmployer) {
    this.coefficient = coefficient;
    this.threshold = threshold;
    this.isDeductible = isDeductible;
  }

  double compute(double amount, double taux) {

    double partWithCoefficient = amount*coefficient;
    double partWithNoCoefficient = 0.0;

    if(amount >= threshold) {
      partWithCoefficient = pass*coefficient;
      partWithNoCoefficient = (amount-threshold);
    }

    return (partWithCoefficient * taux/100) + (partWithNoCoefficient * taux/100);
  }

  @override
  double computeEmployer(double amount) {
    return compute(amount, rateEmployer);
  }

  @override
  double computeEmployee(double amount) {
    return compute(amount, rateEmployee);
  }
}