part of simulator_eurl_sasu;


ServiceIrIs serviceIrIs = new ServiceIrIs();

class ServiceIrIs {

  Logger logger = new Logger('simulator.ServiceIrIs');

  double computeIr(double amount) {

    List<ThresholdIr> thresholds = [new ThresholdIr(0.00, 9700.00, 0.00),
                            new ThresholdIr(9700.00, 26791.00, 14.00),
                            new ThresholdIr(26791.00, 71826.00, 30.00),
                            new ThresholdIr(71826.00, 152108.00, 41.00),
                            new ThresholdIr(152108.00, null, 45.00)];

    double ir = 0.00;

    for(ThresholdIr threshold in thresholds) {

      if(amount > threshold.threshold1 && threshold.threshold2 == null) {
        ir += ((amount - threshold.threshold1) * threshold.rate) / 100;

      } else if(amount > threshold.threshold1 && amount >= threshold.threshold2) {
        ir += ((threshold.threshold2 - threshold.threshold1) * threshold.rate) / 100;

      } else if(amount > threshold.threshold1 && amount < threshold.threshold2) {
        ir += ((amount - threshold.threshold1) * threshold.rate) / 100;
      }
    }

    return ir;
  }

  double computeIs(double profit) {

    double rate1 = 15.00;
    double threshold = 38120.00;
    double rate2 = 33.00;

    double charges = 0.00;
    if(profit <= threshold) {
      charges = profit * rate1 / 100;
    }

    if(profit > threshold) {
      charges = (threshold * rate1 / 100) + ((profit - threshold) * rate2 / 100);
    }

    return charges;
  }
}

class ThresholdIr {

  double threshold1;
  double threshold2;
  double rate;

  ThresholdIr(this.threshold1, this.threshold2, this.rate);
}

